﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Windows;

namespace WpfOsi
{
    /// <summary>
    /// Interaktionslogik für AddInstructionWindow.xaml
    /// </summary>
    public partial class AddInstructionWindow : Window, INotifyPropertyChanged
    {
        //SPS Die Struktur des Views hier mit den Properties abgebildet und im View Bindings dahingehend geändert
        private Context.OsiContext _ctx;

        public AddInstructionWindow()
        {
            InitializeComponent();
            if (!(DesignerProperties.GetIsInDesignMode(this))){
                _ctx = new Context.OsiContext();

                AviableProductionLines = _ctx.ProductionLines;
                CurrentInstruction = new Model.Instruction() { LineID = AviableProductionLines[0].ID, FormularName = "Unnamed", RevisionDate = System.DateTime.Now }; // SPS Stadnardwerte setzen 
                SelectedProductionLine = AviableProductionLines[0]; // SPS Eine vorselektieren
                DataContext = this;
            }
        }
        private void Window_Closing(object sender, CancelEventArgs e)
        {
            _ctx.Dispose();
        }

        private void OkClick(object sender, RoutedEventArgs e)
        {
            // SPS Speichern
            _ctx.Instructions.Add(CurrentInstruction);
            _ctx.SaveChanges();
            DialogResult = true;
        }



        private Model.Instruction _currentInstruction;

        public Model.Instruction CurrentInstruction
        {
            get { return _currentInstruction; }
            set { _currentInstruction = value; RaisePropertyChanged(); }
        }

        private ObservableCollection<Model.ProductionLine> _aviableProductionLines;

        public ObservableCollection<Model.ProductionLine> AviableProductionLines
        {
            get { return _aviableProductionLines; }
            set { _aviableProductionLines = value; RaisePropertyChanged(); }
        }

        private Model.ProductionLine _selectedProductionLine;

        public Model.ProductionLine SelectedProductionLine
        {
            get { return _selectedProductionLine; }
            set { _selectedProductionLine = value; RaisePropertyChanged(); CurrentInstruction.LineID = _selectedProductionLine.ID; }
        }





        #region INotify Implementation
        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void RaisePropertyChanged([CallerMemberName] string prop = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(prop));
        }
        #endregion
    }
}
